package com.example.testellipsis

import android.graphics.Color
import android.os.Bundle
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.AbsoluteSizeSpan
import android.widget.LinearLayout
import androidx.appcompat.app.AppCompatActivity
import androidx.appcompat.widget.AppCompatTextView

class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main);

        val layout: LinearLayout = findViewById<LinearLayout>(R.id.root);
        val textView = AppCompatTextView(this);

        val padding = 74;
        textView.setPadding(padding, padding, padding, padding);
        textView.setTextIsSelectable(false);
        textView.setTextColor(Color.parseColor("#FF0000"));
        textView.setEllipsize(TextUtils.TruncateAt.END);
        textView.setSingleLine(true);
        textView.setMaxLines(1);
        textView.layout(0, 0, 1080, 257);

        // NOTE: If the text size is set in the text view, the problem ceases to exist
        // textView.setTextSize(TypedValue.COMPLEX_UNIT_PX, 83F);

        val sb = SpannableStringBuilder();
        sb.append("This text will be cut-off strangely in Android");

        // Sets the font size of the spannable content to 83px, this
        // causes the ellipsis to appear cut
        var priority = 0;
        var spanFlags = Spannable.SPAN_INCLUSIVE_INCLUSIVE
        spanFlags = spanFlags or (priority shl Spannable.SPAN_PRIORITY_SHIFT and Spannable.SPAN_PRIORITY)
        sb.setSpan(AbsoluteSizeSpan(83), 0, sb.length, spanFlags);

        textView.setText(sb);
        layout.addView(textView);
    }
}